﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace LiuLun.Silverlight.DataAccess
{
    public class BaseDA:IDisposable
    {
        private static readonly string connectionString = System.Configuration.ConfigurationManager.AppSettings["ConnStr"];
        private SqlCommand CMD;
        private SqlConnection Conn;
        public BaseDA()
        {
            PrepareConn();
        }
        protected virtual void PrepareConn()
        {
            Conn = new SqlConnection(connectionString);
            Conn.Open();
            CMD = new SqlCommand();
            CMD.CommandTimeout = 1000 * 60 * 60; // 60分钟
            CMD.Connection = Conn;
            CMD.CommandType = System.Data.CommandType.Text;            
        }
        public int ExecuteNonQuery(string sql)
        {
            CMD.CommandText = sql;
            int retval = CMD.ExecuteNonQuery();
            return retval;
        }
        public DataSet ExecuteDataset(string sql)
        {
            CMD.CommandText = sql;
            using (SqlDataAdapter da = new SqlDataAdapter(CMD))
            {
                DataSet ds = new DataSet();
                da.Fill(ds);
                return ds;
            }
        }
        public SqlDataReader ExecuteDataReader(string sql)
        {
            CMD.CommandText = sql;
            var result = CMD.ExecuteReader();
            return result;
        }
        public object ExecuteScalar(string sql)
        {
            CMD.CommandText = sql;
            var result = CMD.ExecuteScalar();
            return result;
        }
        public void Dispose()
        {
            Conn.Close();
        }
    }
}
